% PROGRAMA PARA REALIZAR ENSAYOS
%
% Este programa permite realizar los test 1, 2.1 y 3 a una misma serie.
% Se pretende utilizar para hacer un anlisis comparativo de los resultados que se obtienen con cada uno de los mtodos.
%
% Aclaracin: 
% Lo que aqu denominamos entropa topolgica no es, en sentido estricto, el valor real de dicha entropa.
% Lo que en realidad representa H es el nmero de permutaciones diferentes que aparecen en la serie.
% Hemos utilizado el nombre de entropa topolgica porque este concepto est directamente relacionado con el nmero de permutaciones diferentes en la serie.

t1=[0 0 0; 0 0 0; 0 0 0];
t2_1=[0 0 0; 0 0 0; 0 0 0];
t3=[0 0 0 0 0; 0 0 0 0 0; 0 0 0 0 0];
resultadoT1=[0 0 0; 0 0 0; 0 0 0];
resultadoT2=[0 0 0; 0 0 0; 0 0 0];
resultadoT3=[0 0 0 0 0; 0 0 0 0 0; 0 0 0 0 0];

for repeticiones=1:400
    
    x(1)=0.45;
    
    for i=2:600
        
        x(i)=x(i-1)+rand;
        
    end
    
    serie=x; 
    m=[4 5 6];
    nivel_confianza=[90 95 99];
    n=length(serie); 
    
    % TEST 1
    
    % CALCULAMOS h (ENTROPA DE PERMUTACIN) %
    
    for j=1:3
    
        trozo_serie1=serie(1:m(j));
        [trozo_ordenado1,permutacion1]=sort(trozo_serie1);
        M_permutaciones=permutacion1;
        Npermutaciones_diferentes=1;
        Fabs_permutacion(1)=1;

        for cont1=2:n-m(j)+1
    
            trozo_serie=serie(cont1:cont1+m(j)-1);
            [trozo_ordenado,permutacion]=sort(trozo_serie);
        
            testigo=0;
    
            for cont2=1:Npermutaciones_diferentes
        
                if(isequal(M_permutaciones(cont2,:),permutacion)==1)
            
                    Fabs_permutacion(cont2)=Fabs_permutacion(cont2)+1;
                    testigo=1;
                    break            
            
                end
        
            end
    
            if(testigo==0)
        
            Npermutaciones_diferentes=Npermutaciones_diferentes+1;    
            M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
            Fabs_permutacion(Npermutaciones_diferentes)=1;
    
            end
    
        end

        Frel_permutacion=Fabs_permutacion/(n-m(j)+1);

        H1=0;

        for cont3=1:Npermutaciones_diferentes
      
            incremento_entropia=-(Frel_permutacion(cont3)*log(Frel_permutacion(cont3)));
            H1=H1+incremento_entropia;
      
        end

        % REALIZAMOS EL CONTRASTE DE HIPTESIS (TEST 1)

        G=2*(n-m(j)+1)*(log(factorial(m(j)))-H1);

        grados_libertad=factorial(m(j))-1;

        for k=1:3

            chi_cuadrado=chi2inv(nivel_confianza(k)/100,grados_libertad);

            if(G<chi_cuadrado)
    
                t1(k,j)=1;
    
            else
        
                t1(k,j)=0;
        
            end

        end
            
    end

    resultadoT1=resultadoT1+t1;
    
    % TEST 2-1
    
    for j=1:3
    
        % CALCULAMOS H (ENTROPA TOPOLGICA)

        trozo_serie1=serie(1:m(j));
        [trozo_ordenado1,permutacion1]=sort(trozo_serie1);
        M_permutaciones=permutacion1;
        Npermutaciones_diferentes=1;
        Fabs_permutacion(1)=1;

        for cont1=m(j)+1:m(j):n-m(j)+1
    
            trozo_serie=serie(cont1:cont1+m(j)-1);
            [trozo_ordenado,permutacion]=sort(trozo_serie);
        
            testigo=0;
    
            for cont2=1:Npermutaciones_diferentes
        
                if(isequal(M_permutaciones(cont2,:),permutacion)==1)
            
                    Fabs_permutacion(cont2)=Fabs_permutacion(cont2)+1;
                    testigo=1;
                    break            
            
                end
        
            end
    
            if(testigo==0)
        
            Npermutaciones_diferentes=Npermutaciones_diferentes+1;    
            M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
            Fabs_permutacion(Npermutaciones_diferentes)=1;
    
            end
    
        end

        H2=Npermutaciones_diferentes;

        % REALIZAMOS EL CONTRASTE DE HIPTESIS (TEST 2-1)

        for k=1:3

            valores_limite=load(strcat('VECTORm',num2str(m(j)),'nc',num2str(nivel_confianza(k)),'.txt'));
            tam_valores_limite=length(valores_limite);
            
            if tam_valores_limite>=fix(n/(m(j)))
            
                valor_limite=valores_limite(fix(n/(m(j))));
                
            else
                
                valor_limite=valores_limite(tam_valores_limite);
            
            end
            
            if(H2>=valor_limite)
    
                t2_1(k,j)=1;
    
            else
        
                t2_1(k,j)=0;
        
            end

        end
            
    end
    
    resultadoT2=resultadoT2+t2_1;
        
    % TEST 3

    mMaxima=6;
    desviacion_tipica=std(serie(:));
    epsilon=1.5*desviacion_tipica;

    % CALCULAMOS Cn

    sumaCn=0;

    for cont1=1:n-1
   
        elementoSerie=serie(cont1);
    
        for cont2=cont1+1:n
       
            normaDiferencia=abs(elementoSerie-serie(cont2));
        
            if(normaDiferencia<epsilon)
            
                matriz(cont1,cont2)=1;
                sumaCn=sumaCn+1;
            
            else
            
                matriz(cont1,cont2)=0;
            
            end
        
        end
    
    end

    Cn=sumaCn/(n*(n-1)/2); 

    % CALCULAMOS C1n

    sumaAuxiliar=0;

    for cont3=1:mMaxima-1
   
        for cont4=cont3+1:n
        
            sumaAuxiliar=sumaAuxiliar+matriz(cont3,cont4);
        
        end
    
        vectorC1n(cont3)=(sumaCn-sumaAuxiliar)/((n-cont3)*(n-cont3-1)/2); % vector de los valores de C1n
        vectorC1n_modificado(cont3)=vectorC1n(cont3)^(cont3+1);
    
    end

    % CALCULAMOS Kn

    sumaKn=0;

    for cont5=1:n-2
    
        for cont6=cont5+1:n-1
        
            if(isequal(matriz(cont5,cont6),1)==1)
            
                for cont7=cont6+1:n
                
                    sumaKn=sumaKn+matriz(cont6,cont7);
                
                end
            
            end
        
        end
    
    end

    Kn=sumaKn/(n*(n-1)*(n-2)/6); 

    % CALCULAMOS Cmn

    nCmn=n;

    for m=2:mMaxima
    
        sumaCmn=0;
    
        for cont8=1:nCmn-2
        
            for cont9=cont8+1:nCmn-1
            
                auxiliar=matriz(cont8,cont9)*matriz(cont8+1,cont9+1);
                matriz(cont8,cont9)=auxiliar;
                sumaCmn=sumaCmn+auxiliar;
            
            end
        
        end
    
        vectorCmn(m-1)=sumaCmn/((n-m+1)*(n-m)/2); % vector de los valores de Cmn
        nCmn=nCmn-1;
    
    end

    % CALCULAMOS Tmn, Vmn y Wmn
    % REALIZAMOS EL CONTRASTE DE HIPTESIS

    for m=2:mMaxima
   
        vectorTmn(m-1)=vectorCmn(m-1)-vectorC1n_modificado(m-1); % vector de los valores de Tmn
    
        suma_Vmn=0;
    
        for cont10=1:m-1
    
            incremento_suma_Vmn=(Kn^(m-cont10))*(Cn^(2*cont10));
            suma_Vmn=suma_Vmn+incremento_suma_Vmn;
    
        end

        vectorVmn(m-1)=2*sqrt(Kn^m+2*suma_Vmn+(m-1)^2*Cn^(2*m)-m^2*Kn*Cn^(2*m-2)); % vector de los valores de Vmn
        vectorWmn(m-1)=sqrt(n-m+1)*vectorTmn(m-1)/vectorVmn(m-1); % vector de los valores de Wmn
    
        for j=1:3
    
            if (abs(vectorWmn(m-1))<=norminv((1+nivel_confianza(j)/100)/2,0,1))
    
                matrizTest3(j,m-1)=1;

            else
    
                matrizTest3(j,m-1)=0;
    
            end
    
        end
    
    end

    t3=matrizTest3;

    resultadoT3=resultadoT3+t3;

end

resultadoT1=[100 100 100; 100 100 100; 100 100 100]-resultadoT1*(100/repeticiones) 
resultadoT2=[100 100 100; 100 100 100; 100 100 100]-resultadoT2*(100/repeticiones)
resultadoT3=[100 100 100 100 100; 100 100 100 100 100; 100 100 100 100 100]-resultadoT3*(100/repeticiones)
