% MTODO 2 
% TEST 2-1
%
% La referencia utilizada ha sido:
%
%	J. S. Cnovas, A. Guillamn
%	PERMUTATIONS AND TIME SERIES ANALYSIS
%	Chaos 19 (2009), 197-235
%
% Seguimos los siguientes pasos para hacer el test:
% 
% PASO 1: Introducimos la serie temporal con la que vamos a trabajar.
% PASO 2: Calculamos H (entropa topolgica).
% PASO 3: Realizamos el contraste de hiptesis.
%
% Aclaracin: 
% Lo que aqu denominamos entropa topolgica no es, en sentido estricto, el valor real de dicha entropa.
% Lo que en realidad representa H es el nmero de permutaciones diferentes que aparecen en la serie.
% Hemos utilizado el nombre de entropa topolgica porque este concepto est directamente relacionado con el nmero de permutaciones diferentes en la serie.

function t2_1=test_2_1(serie_temp,m,nivel_confianza)

% PASO 1
% INTRODUCIMOS LA SERIE TEMPORAL CON LA QUE VAMOS A TRABAJAR

serie=serie_temp; % serie temporal
T=length(serie); % nmero de elementos de la serie

% PASO 2
% CALCULAMOS H (ENTROPA TOPOLGICA)

trozo_serie1=serie(1:m);
[trozo_ordenado1,permutacion1]=sort(trozo_serie1);
M_permutaciones=permutacion1;
Npermutaciones_diferentes=1;
Fabs_permutacion(1)=1;

for cont1=m+1:m:T-m+1
    
    trozo_serie=serie(cont1:cont1+m-1);
    [trozo_ordenado,permutacion]=sort(trozo_serie);
        
    testigo=0;
    
    for cont2=1:Npermutaciones_diferentes
        
        if(isequal(M_permutaciones(cont2,:),permutacion)==1)
            
            Fabs_permutacion(cont2)=Fabs_permutacion(cont2)+1;
            testigo=1;
            break            
            
        end
        
    end
    
    if(testigo==0)
        
    Npermutaciones_diferentes=Npermutaciones_diferentes+1;    
    M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
    Fabs_permutacion(Npermutaciones_diferentes)=1;
    
    end
    
end

H=Npermutaciones_diferentes;

% PASO 3
% REALIZAMOS EL CONTRASTE DE HIPTESIS

valores_limite=load(strcat('VECTORm',num2str(m),'nc',num2str(nivel_confianza),'.txt'));
valor_limite=valores_limite(fix(T/m));

if(H>=valor_limite)
    
    t2_1=1;
    
else
        
    t2_1=0;
        
end

% Agregamos al resultado de salida los valores de Tmn, Vmn y Wmn

auxiliar=t2_1;
t2_1=[H valor_limite auxiliar];