(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     12697,        226]
NotebookOptionsPosition[     12453,        213]
NotebookOutlinePosition[     12796,        228]
CellTagsIndexPosition[     12753,        225]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{"\"\<C\[AAcute]lculo del n\[UAcute]mero de permutaciones \
diferentes a partir del que hay una probabilidad mayor o igual a \
Nconfianza/100 de encontrar el valor del estad\[IAcute]stico de contraste \
(bajo la suposici\[OAcute]n de que la serie temporal sea iid.)\>\"", "\
\[IndentingNewLine]", 
 RowBox[{"\"\<El tama\[NTilde]o de la serie temporal en estudio es m*k.\>\"", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"ClearAll", "[", 
  RowBox[{"m", ",", "prob", ",", "k", ",", "suma", ",", "tope", ",", "t"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k", "=", "240"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"prob", "[", 
    RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"StirlingS2", "[", 
      RowBox[{"k", ",", "t"}], "]"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "!"}], ")"}], "!"}], "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", 
        RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"suma", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tope", "=", 
   RowBox[{"Min", "[", 
    RowBox[{
     RowBox[{"m", "!"}], ",", "k"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"For", " ", "[", 
   RowBox[{
    RowBox[{"t", "=", "tope"}], ",", 
    RowBox[{"t", "\[GreaterSlantEqual]", "1"}], ",", 
    RowBox[{"t", "--"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"suma", "=", 
      RowBox[{"suma", "+", 
       RowBox[{"prob", "[", 
        RowBox[{"k", ",", "m", ",", "t"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"suma", "\[GreaterSlantEqual]", "0.99"}], ",", 
       RowBox[{"Break", "[", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}],
   ";"}], "\[IndentingNewLine]", "t"}], "Input",
 CellChangeTimes->{{3.510610273832362*^9, 3.5106103103832264`*^9}, {
   3.510610365763324*^9, 3.5106104226410236`*^9}, {3.510610492950347*^9, 
   3.510610662054644*^9}, {3.510610821393324*^9, 3.510610821705324*^9}, {
   3.5106110106372566`*^9, 3.5106110438497148`*^9}, {3.510611164047926*^9, 
   3.5106112127044115`*^9}, {3.5106112459324694`*^9, 
   3.5106112859777403`*^9}, {3.5106122575942464`*^9, 
   3.5106122579218473`*^9}, {3.5113626170248566`*^9, 
   3.5113626824045715`*^9}, {3.511364008850046*^9, 3.511364013305301*^9}, {
   3.5113641146495075`*^9, 3.511364116457611*^9}, {3.511364444185505*^9, 
   3.5113644442965107`*^9}, {3.5113657752412825`*^9, 
   3.5113657825136447`*^9}, {3.511365861833746*^9, 3.5113658622167673`*^9}, {
   3.511365991958521*^9, 3.5113660182899075`*^9}, 3.5113662263425198`*^9, {
   3.51136639501768*^9, 3.5113664072983828`*^9}, {3.5113664453623705`*^9, 
   3.5113666948123865`*^9}, {3.511387477280843*^9, 3.511387491289667*^9}, {
   3.5113875704598064`*^9, 3.511387575857416*^9}, {3.5113887859203415`*^9, 
   3.5113888674928846`*^9}, {3.5114673862659388`*^9, 
   3.5114674088235784`*^9}, {3.5114674547032595`*^9, 3.511467456216462*^9}, {
   3.5114675958679075`*^9, 3.5114676188155475`*^9}, {3.5114676501872025`*^9, 
   3.511467650514803*^9}, {3.511468604584587*^9, 3.5114686064565907`*^9}, {
   3.51147022637759*^9, 3.5114702344090495`*^9}, {3.5114702892501864`*^9, 
   3.511470304858079*^9}, {3.5114704231228437`*^9, 3.511470432753394*^9}, {
   3.5114715978662643`*^9, 3.5114715996581297`*^9}, {3.5114716394926977`*^9, 
   3.511471829708087*^9}, 3.51147186658384*^9, {3.511471907107689*^9, 
   3.511471912593886*^9}, {3.5114719441532917`*^9, 3.51147196830968*^9}, {
   3.511472547222769*^9, 3.5114725580846605`*^9}, {3.511472959972697*^9, 
   3.5114729722811184`*^9}, {3.51147370350069*^9, 3.51147376065919*^9}, {
   3.511509436122347*^9, 3.511509495652051*^9}, {3.511509947640712*^9, 
   3.511509976204362*^9}, {3.511510138647447*^9, 3.511510141564652*^9}, {
   3.5115101769923143`*^9, 3.5115101809547215`*^9}, {3.5115102134651785`*^9, 
   3.511510253744449*^9}, {3.5115103585298333`*^9, 3.511510358748234*^9}, {
   3.511512474766348*^9, 3.511512486546769*^9}, {3.5115129053329973`*^9, 
   3.511512978153926*^9}, {3.5115130308508177`*^9, 3.5115130374184294`*^9}, {
   3.511513090474123*^9, 3.5115130982897367`*^9}, {3.511513147461023*^9, 
   3.5115131514858303`*^9}, {3.5115131878182936`*^9, 
   3.5115131886918955`*^9}, {3.5115132233395557`*^9, 
   3.5115132413263874`*^9}, {3.5115133553469877`*^9, 3.511513365986207*^9}, {
   3.5115134367635307`*^9, 3.511513449773954*^9}, {3.5115135202080774`*^9, 
   3.51151355005093*^9}, {3.5115138631746798`*^9, 3.511513895014336*^9}, {
   3.511514534350259*^9, 3.5115145347714596`*^9}, {3.5115146160944023`*^9, 
   3.511514647762458*^9}, {3.5115147030021553`*^9, 3.51151470584136*^9}, {
   3.5115264119425497`*^9, 3.511526422098168*^9}, {3.511707904533733*^9, 
   3.5117079046897335`*^9}, {3.511707998664298*^9, 3.5117079990542994`*^9}, {
   3.511708136740141*^9, 3.511708142886552*^9}, {3.511708191496237*^9, 
   3.5117081934774404`*^9}, {3.511708263396763*^9, 3.5117082923036137`*^9}, {
   3.5117083837509747`*^9, 3.511708388103382*^9}, {3.5117084240458455`*^9, 
   3.511708424638646*^9}, {3.5117090758781853`*^9, 3.511709121258665*^9}, {
   3.511709224187646*^9, 3.511709303435785*^9}, {3.511709364556692*^9, 
   3.5117093652274933`*^9}, {3.51170940305756*^9, 3.511709413369178*^9}, {
   3.511725445989783*^9, 3.5117254723070292`*^9}, {3.511725557639179*^9, 
   3.5117256150004797`*^9}, {3.511725670817378*^9, 3.5117257125318513`*^9}, {
   3.511725804774813*^9, 3.5117258066156163`*^9}, {3.511726073547685*^9, 
   3.5117261078365455`*^9}, {3.511726199221506*^9, 3.5117262007035084`*^9}, {
   3.5117306695080547`*^9, 3.5117306699760556`*^9}, 3.511730756202178*^9, {
   3.5117309660040894`*^9, 3.511730966867319*^9}, 3.5117310181644893`*^9, {
   3.5117310621800623`*^9, 3.5117310627480946`*^9}, {3.5117313004366083`*^9, 
   3.51173133483666*^9}, {3.5117315009482584`*^9, 3.5117316219644156`*^9}, {
   3.5117316622363434`*^9, 3.5117316646766768`*^9}, {3.511731790820146*^9, 
   3.511731846397253*^9}, {3.511732219779643*^9, 3.5117322978284297`*^9}, {
   3.511732357404271*^9, 3.511732476644583*^9}, {3.5120532480341206`*^9, 
   3.512053298272539*^9}, {3.5120536019463205`*^9, 3.5120536074338274`*^9}, {
   3.512054978424448*^9, 3.5120549798693285`*^9}, {3.512055064479362*^9, 
   3.5120550752065496`*^9}, {3.512055119966604*^9, 3.5120551301705637`*^9}, {
   3.5120552209597316`*^9, 3.512055243912961*^9}, {3.512055536642028*^9, 
   3.5120556406975365`*^9}, {3.512055715040616*^9, 3.5120557423123116`*^9}, {
   3.51205577608928*^9, 3.5120559034770126`*^9}, {3.5120559379387026`*^9, 
   3.512055939626795*^9}, {3.5120559737954626`*^9, 3.512055981018059*^9}, {
   3.5120560314177523`*^9, 3.5120560570257573`*^9}, {3.5120560948104286`*^9, 
   3.512056109141148*^9}, {3.512057884944441*^9, 3.5120579467361493`*^9}, {
   3.512061508706046*^9, 3.5120615190800643`*^9}, {3.512063627062992*^9, 
   3.512063631022811*^9}, {3.512063702606907*^9, 3.5120637578993063`*^9}, {
   3.5120638077886057`*^9, 3.51206385766772*^9}, {3.5120639479954414`*^9, 
   3.512063952804302*^9}, {3.5120643784854975`*^9, 3.512064386172718*^9}, {
   3.512064588138706*^9, 3.512064588370717*^9}, {3.5120649127171865`*^9, 
   3.512064925443281*^9}, {3.5120653694985075`*^9, 3.51206537064857*^9}, {
   3.5120654178075666`*^9, 3.512065466313635*^9}, {3.5120655910107565`*^9, 
   3.512065610027948*^9}, {3.5120657112602997`*^9, 3.512065726267228*^9}, {
   3.5120659994352603`*^9, 3.5120660203779435`*^9}, {3.5120661857607565`*^9, 
   3.5120661858277607`*^9}, {3.5120675149361534`*^9, 
   3.5120675990371013`*^9}, {3.5120677059832883`*^9, 3.512067721146515*^9}, {
   3.5120677986514487`*^9, 3.512067813143874*^9}, {3.5120772974370785`*^9, 
   3.5120773333171415`*^9}, {3.5120774229236994`*^9, 3.512077424156101*^9}, {
   3.5120776740997405`*^9, 3.5120776999177856`*^9}, 3.5120778312856164`*^9, {
   3.5120785088485537`*^9, 3.5120785109389577`*^9}, {3.512078748932976*^9, 
   3.512078782098634*^9}, {3.5120788200847006`*^9, 3.5120788294939175`*^9}, {
   3.512078878446803*^9, 3.512078918679274*^9}, {3.512079187639346*^9, 
   3.5120792623634777`*^9}, {3.512139568860817*^9, 3.512139589593253*^9}, {
   3.5121398436396995`*^9, 3.5121398955877905`*^9}, {3.512139927115446*^9, 
   3.5121399517478895`*^9}, {3.5121414247336764`*^9, 3.512141540127079*^9}, {
   3.5121415859131594`*^9, 3.5121416143208094`*^9}, {3.5121416789985228`*^9, 
   3.512141760477466*^9}, 3.512141798369933*^9, {3.5121418982569084`*^9, 
   3.5121419737298408`*^9}, {3.512142011965508*^9, 3.512142012433509*^9}, {
   3.512142190757422*^9, 3.51214219540623*^9}, {3.51214242878264*^9, 
   3.51214246857831*^9}, {3.512142504520773*^9, 3.5121425180147967`*^9}, {
   3.51214254831005*^9, 3.5121425564220643`*^9}, {3.5121426216457787`*^9, 
   3.512142639975811*^9}, 3.51214661615551*^9, {3.5121469741323705`*^9, 
   3.5121470428640347`*^9}, {3.512147077714924*^9, 3.512147081779893*^9}, {
   3.5122377887379594`*^9, 3.5122377893775606`*^9}, {3.512237935908618*^9, 
   3.5122379369382195`*^9}, {3.5122380216775684`*^9, 
   3.5122380519884214`*^9}, {3.512239792417616*^9, 3.512239846892911*^9}, {
   3.5122399679631195`*^9, 3.5122399715355253`*^9}, {3.5122400325940323`*^9, 
   3.5122400891249313`*^9}, {3.512240142276225*^9, 3.512240171393476*^9}, {
   3.512240632904687*^9, 3.5122406765691633`*^9}, {3.512240716271233*^9, 
   3.512240724601648*^9}, {3.5122415806767426`*^9, 3.51224161796838*^9}, {
   3.5122417339655285`*^9, 3.5122417359572372`*^9}, {3.512243189807561*^9, 
   3.5122431908474054`*^9}, {3.5122897067949066`*^9, 
   3.5122898198171053`*^9}, {3.5122898785668087`*^9, 
   3.5122898804700117`*^9}, {3.5122899280656953`*^9, 3.512290094689588*^9}, {
   3.5122902819055166`*^9, 3.5122903227619886`*^9}, {3.5122903965501184`*^9, 
   3.5122904627254343`*^9}, {3.512290533565159*^9, 3.5122906072908883`*^9}, {
   3.512290673247804*^9, 3.512290674074606*^9}, {3.5122908267676735`*^9, 
   3.512290827516475*^9}, {3.512290875392959*^9, 3.5122909350006638`*^9}, {
   3.512290966075918*^9, 3.5122909900219603`*^9}, {3.5122910909073377`*^9, 
   3.512291091203738*^9}, {3.512292128808361*^9, 3.5122921291359615`*^9}, {
   3.5122921663420267`*^9, 3.512292167168828*^9}, {3.5122922219561243`*^9, 
   3.512292222533325*^9}, {3.512292271829412*^9, 3.512292315103888*^9}, {
   3.512292870246463*^9, 3.5122928978897114`*^9}, {3.5123039125035076`*^9, 
   3.51230395908519*^9}, {3.5123039899420433`*^9, 3.5123040973794327`*^9}, {
   3.512304127487485*^9, 3.5123041353498993`*^9}, {3.5123041945052032`*^9, 
   3.512304302784993*^9}, {3.5123043396478577`*^9, 3.5123043681335077`*^9}, {
   3.5123044036391706`*^9, 3.512304404481572*^9}, {3.512304508720955*^9, 
   3.512304527503388*^9}, {3.5123048334667253`*^9, 3.5123048576467676`*^9}, {
   3.512306260635232*^9, 3.512306279252865*^9}, {3.512306325163746*^9, 
   3.5123063462237825`*^9}, {3.525619074006565*^9, 3.5256190771465693`*^9}, {
   3.5256192202029853`*^9, 3.525619223728117*^9}, {3.525619275201988*^9, 
   3.5256192869785957`*^9}, {3.5256222077294793`*^9, 3.525622228774683*^9}, {
   3.5256225403615046`*^9, 3.5256225562144117`*^9}, {3.525622685641814*^9, 
   3.525622686704875*^9}, {3.525622782636362*^9, 3.5256228537154274`*^9}, 
   3.525623109402052*^9, {3.5256232236105843`*^9, 3.525623274546498*^9}, {
   3.52563207333289*^9, 3.525632124154866*^9}, {3.5256322045704994`*^9, 
   3.525632363314364*^9}, {3.5374068536607227`*^9, 3.5374068593547325`*^9}, 
   3.5374069397104735`*^9, {3.537446474000862*^9, 3.5374465223453474`*^9}, {
   3.537446601905487*^9, 3.5374466160547113`*^9}}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 11892, 191, 312, "Input"]
}
]
*)

(* End of internal cache information *)
