(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      4069,        120]
NotebookOptionsPosition[      3827,        107]
NotebookOutlinePosition[      4170,        122]
CellTagsIndexPosition[      4127,        119]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{"\"\<C\[AAcute]lculo del tama\[NTilde]o de la serie temporal (T=m*k) \
a partir del cual Pr(W=m!)>0.99 (bajo la suposici\[OAcute]n de que la serie \
es iid).\>\"", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"ClearAll", "[", 
  RowBox[{
  "m", ",", "Nconfianza", ",", "iMax", ",", "prob", ",", "Vauxiliar", ",", 
   "contador", ",", "suma1", ",", "tope1", ",", "t1", ",", "kMax", ",", 
   "tabla", ",", "f", ",", "i", ",", "k", ",", "suma", ",", "tope", ",", 
   "t"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "6"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Nconfianza", "=", 
   RowBox[{"{", 
    RowBox[{"0.9", ",", "0.95", ",", "0.99"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"iMax", "=", 
   RowBox[{"Length", "[", "Nconfianza", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"prob", "[", 
    RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"StirlingS2", "[", 
      RowBox[{"k", ",", "t"}], "]"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "!"}], ")"}], "!"}], "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", 
        RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Vauxiliar", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"contador", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"While", "[", 
   RowBox[{
    RowBox[{"Vauxiliar", "<", 
     RowBox[{"m", "!"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"suma1", "=", "0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"tope1", "=", 
      RowBox[{"Min", "[", 
       RowBox[{
        RowBox[{"m", "!"}], ",", "contador"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", " ", "[", 
      RowBox[{
       RowBox[{"t1", "=", "tope1"}], ",", 
       RowBox[{"t1", "\[GreaterSlantEqual]", "1"}], ",", 
       RowBox[{"t1", "--"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"suma1", "=", 
         RowBox[{"suma1", "+", 
          RowBox[{"prob", "[", 
           RowBox[{"contador", ",", "m", ",", "t1"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"suma1", "\[GreaterSlantEqual]", 
           RowBox[{"Part", "[", 
            RowBox[{"Nconfianza", ",", "iMax"}], "]"}]}], ",", 
          RowBox[{"Break", "[", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Vauxiliar", "=", "t1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"contador", "=", 
      RowBox[{"contador", "+", "1"}]}], ";"}]}], "\[IndentingNewLine]", "]"}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{"kMax", "=", 
  RowBox[{"contador", "-", "1"}]}]}], "Input",
 CellChangeTimes->{{3.527262988810194*^9, 3.527263011742234*^9}, {
   3.5272630468110957`*^9, 3.5272630717243395`*^9}, 3.5272631869773417`*^9, {
   3.5272640528256626`*^9, 3.527264062014079*^9}, {3.537406623497918*^9, 
   3.537406682637622*^9}}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 3266, 85, 412, "Input"]
}
]
*)

(* End of internal cache information *)
