(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     26916,        568]
NotebookOptionsPosition[     26671,        555]
NotebookOutlinePosition[     27014,        570]
CellTagsIndexPosition[     26971,        567]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"M\[CapitalEAcute]TODO", " ", "1"}], "*)"}], " ", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"TEST", " ", "1"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"La", " ", "referencia", " ", "utilizada", " ", "ha", " ", 
    RowBox[{"sido", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"M", ".", " ", "Matilla"}], ",", " ", 
    RowBox[{"M", ".", " ", "Ru\[IAcute]z"}]}], "*)"}], "\[IndentingNewLine]", 
  "\t", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"A", " ", "NON"}], "-", 
    RowBox[{
    "PARAMETRIC", " ", "INDEPENDENCE", " ", "TEST", " ", "USING", " ", 
     "PERMUTATION", " ", "ENTROPY"}]}], "*)"}], "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Journal", " ", "of", " ", "Econometrics", " ", "144", " ", 
     RowBox[{"(", "2008", ")"}]}], ",", " ", 
    RowBox[{"139", "-", "155"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Realizamos", " ", "el", " ", "test", " ", "a", " ", "trav\[EAcute]s", " ",
     "de", " ", "los", " ", "pasos", " ", "que", " ", "se", " ", "exponen", 
    " ", "a", " ", 
    RowBox[{"continuaci\[OAcute]n", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "1"}], ":", " ", 
    RowBox[{
    "Introducimos", " ", "la", " ", "serie", " ", "temporal", " ", "con", " ",
      "la", " ", "que", " ", "vamos", " ", "a", " ", 
     RowBox[{"trabajar", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "2"}], ":", " ", 
    RowBox[{"Calculamos", " ", "h", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"entrop\[IAcute]a", " ", "de", " ", "permutaci\[OAcute]n"}], 
       ")"}], "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "3"}], ":", " ", 
    RowBox[{"Realizamos", " ", "el", " ", "contraste", " ", "de", " ", 
     RowBox[{"hip\[OAcute]tesis", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", 
    RowBox[{
    "serie", ",", "m", ",", "nivelConfianza", ",", "nivelSignificacion", ",", 
     "T", ",", "trozo1Serie", ",", "permutacion1", ",", "Mpermutaciones", ",",
      "NpermutacionesDiferentes", ",", "FabsPermutacion", ",", "cont1", ",", 
     "trozoSerie", ",", "permutacion", ",", "testigo", ",", "cont2", ",", 
     "FrelPermutacion", ",", "H", ",", "cont3", ",", "incrementoH", ",", "G", 
     ",", "gradosLibertad", ",", "chiCuadrado", ",", "test1"}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"PASO", " ", "1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "INTRODUCIMOS", " ", "LA", " ", "SERIE", " ", "CON", " ", "LA", " ", 
     "QUE", " ", "VAMOS", " ", "A", " ", "TRABAJAR"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"serie", "=", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", "120"}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"serie", " ", "temporal"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "4"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"dimensi\[OAcute]n", " ", "de", " ", "inmersi\[OAcute]n", " ", 
     RowBox[{"(", 
      RowBox[{"'", "embedding", " ", 
       RowBox[{"dimension", "'"}]}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nivelConfianza", "=", "95"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"nivel", " ", "de", " ", "confianza", " ", "del", " ", "test"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"nivelSignificacion", "=", 
     RowBox[{"1", "-", 
      RowBox[{"(", 
       RowBox[{"nivelConfianza", "/", "100"}], ")"}]}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "nivel", " ", "de", " ", "significaci\[OAcute]n", " ", "del", " ", 
      "test"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"T", "=", 
     RowBox[{"Length", "[", "serie", "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "de", " ", "elementos", " ", "de", " ", "la", " ",
       "serie", " ", "temporal"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"PASO", " ", "2"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"CALCULAMOS", " ", "h", " ", 
      RowBox[{"(", 
       RowBox[{
       "ENTROP\[CapitalIAcute]A", " ", "DE", " ", 
        "PERMUTACI\[CapitalOAcute]N"}], ")"}]}], "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Para", " ", "el", " ", "c\[AAcute]lculo", " ", "de", " ", "la", " ", 
      "entrop\[IAcute]a", " ", "de", " ", 
      RowBox[{"permutaci\[OAcute]n", " ", "'"}], 
      RowBox[{"H", "'"}], " ", "es", " ", "necesario", " ", "hacer", " ", 
      "unos", " ", "c\[AAcute]lculos", " ", 
      RowBox[{"previos", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Hay", " ", "que", " ", "determinar", " ", "la", " ", "frecuencia", " ", 
      "absoluta", " ", "de", " ", "cada", " ", "una", " ", "de", " ", "las", 
      " ", "posibles", " ", 
      RowBox[{"permutaciones", "."}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"trozo1Serie", "=", 
     RowBox[{"serie", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "m"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"permutacion1", "=", 
     RowBox[{"Ordering", "[", "trozo1Serie", "]"}]}], ";"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Mpermutaciones", "=", 
     RowBox[{"{", "permutacion1", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NpermutacionesDiferentes", "=", "1"}], ";"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FabsPermutacion", "=", 
     RowBox[{"{", "1", "}"}]}], ";"}], " ", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"cont1", "=", "2"}], ",", 
      RowBox[{"cont1", "\[LessSlantEqual]", 
       RowBox[{"T", "-", "m", "+", "1"}]}], ",", 
      RowBox[{"cont1", "++"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"trozoSerie", "=", 
        RowBox[{"serie", "[", 
         RowBox[{"[", 
          RowBox[{"cont1", ";;", 
           RowBox[{"cont1", "+", "m", "-", "1"}]}], "]"}], "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"permutacion", "=", 
        RowBox[{"Ordering", "[", "trozoSerie", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"testigo", "=", "0"}], ";", " ", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"cont2", "=", "1"}], ",", 
         RowBox[{"cont2", "\[LessSlantEqual]", "NpermutacionesDiferentes"}], 
         ",", 
         RowBox[{"cont2", "++"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mpermutaciones", "[", 
              RowBox[{"[", "cont2", "]"}], "]"}], "\[Equal]", "permutacion"}],
             ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"FabsPermutacion", "[", 
               RowBox[{"[", "cont2", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"FabsPermutacion", "[", 
                RowBox[{"[", "cont2", "]"}], "]"}], "+", "1"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"testigo", "=", "1"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Break", "[", "]"}], ";"}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"testigo", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Mpermutaciones", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"Mpermutaciones", ",", "permutacion"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"NpermutacionesDiferentes", "=", 
           RowBox[{"NpermutacionesDiferentes", "+", "1"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"FabsPermutacion", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"FabsPermutacion", ",", "1"}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "Una", " ", "vez", " ", "calculadas", " ", "las", " ", "frecuencias", 
      " ", "absolutas", " ", "de", " ", "las", " ", "permutaciones"}], ",", 
     " ", 
     RowBox[{"calculamos", " ", "las", " ", "frecuencias", " ", 
      RowBox[{"relativas", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FrelPermutacion", "=", 
     RowBox[{"FabsPermutacion", "/", 
      RowBox[{"(", 
       RowBox[{"T", "-", "m", "+", "1"}], ")"}]}]}], ";"}], " ", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Con", " ", "las", " ", "frecuencias", " ", "relativas", " ", "de", " ", 
     "las", " ", "permutaciones", " ", "ya", " ", "se", " ", "puede", " ", 
     "determinar", " ", "el", " ", "valor", " ", "de", " ", "la", " ", 
     "entrop\[IAcute]a", " ", "de", " ", "permutaci\[OAcute]n", " ", 
     RowBox[{"H", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "La", " ", "expresi\[OAcute]n", " ", "matem\[AAcute]tica", " ", "de", " ",
      "la", " ", "entrop\[IAcute]a", " ", "de", " ", "permutaci\[OAcute]n", 
     " ", 
     RowBox[{"es", ":"}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\t", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"h", 
      RowBox[{"(", "m", ")"}]}], "=", 
     RowBox[{"-", 
      RowBox[{"\[Sum]", 
       RowBox[{
        SubscriptBox["p", "\[Pi]"], "ln", 
        RowBox[{"(", 
         SubscriptBox["p", "\[Pi]"], ")"}]}]}]}]}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\t", 
   RowBox[{"(*", 
    RowBox[{"donde", " ", 
     SubscriptBox["p", "\[Pi]"], " ", "es", " ", "la", " ", "frecuencia", " ",
      "relativa", " ", "de", " ", "cada", " ", "permutaci\[OAcute]n"}], 
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"H", "=", "0"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"entrop\[IAcute]a", " ", "de", " ", "permutaci\[OAcute]n"}], 
     "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"cont3", "=", "1"}], ",", 
      RowBox[{"cont3", "\[LessSlantEqual]", "NpermutacionesDiferentes"}], ",", 
      RowBox[{"cont3", "++"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"incrementoH", "=", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"FrelPermutacion", "[", 
           RowBox[{"[", "cont3", "]"}], "]"}]}], "*", 
         RowBox[{"Log", "[", 
          RowBox[{"FrelPermutacion", "[", 
           RowBox[{"[", "cont3", "]"}], "]"}], "]"}]}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"H", "=", 
        RowBox[{"H", "+", "incrementoH"}]}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"PASO", " ", "3"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "REALIZAMOS", " ", "EL", " ", "CONTRASTE", " ", "DE", " ", 
     "HIP\[CapitalOAcute]TESIS"}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Calculamos", " ", "'"}], 
     RowBox[{"G", "'"}], " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"estad\[IAcute]stico", " ", "de", " ", "contraste"}], ")"}], 
      "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Su", " ", "f\[OAcute]rmula", " ", 
     RowBox[{"es", ":"}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\t", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"G", 
      RowBox[{"(", "m", ")"}]}], "=", 
     RowBox[{"2", 
      RowBox[{"(", 
       RowBox[{"T", "-", "m", "+", "1"}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"ln", 
         RowBox[{"(", 
          RowBox[{"m", "!"}], ")"}]}], "-", 
        RowBox[{"h", 
         RowBox[{"(", "m", ")"}]}]}], ")"}]}]}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"G", "=", 
     RowBox[{"2", "*", 
      RowBox[{"(", 
       RowBox[{"T", "-", "m", "+", "1"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"m", "!"}], "]"}], "-", "H"}], ")"}]}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"estad\[IAcute]stico", " ", "de", " ", "contraste", " ", "G"}], 
     "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Es", " ", "interesante", " ", "hacer", " ", "notar", " ", "que", " ", 
       "el", " ", "estad\[IAcute]stico", " ", "de", " ", "contraste", " ", 
       "no", " ", "depende"}], ",", " ", "\[UAcute]nicamente", ",", " ", 
      RowBox[{
      "de", " ", "la", " ", "entrop\[IAcute]a", " ", "de", " ", 
       "permutaci\[OAcute]n", " ", 
       RowBox[{"h", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Tambi\[EAcute]n", " ", "depende", " ", "del", " ", "n\[UAcute]mero", 
       " ", "de", " ", "elementos", " ", "de", " ", "la", " ", "serie", " ", 
       "T"}], ",", " ", 
      RowBox[{"y", " ", "del", " ", "valor", " ", "de", " ", "m", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"'", "embedding", " ", 
          RowBox[{"dimension", "'"}]}], ")"}], "."}]}]}], "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"gradosLibertad", "=", 
     RowBox[{
      RowBox[{"m", "!"}], "-", "1"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"grados", " ", "de", " ", "libertad"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"chiCuadrado", "=", 
     RowBox[{"InverseCDF", "[", 
      RowBox[{
       RowBox[{"ChiSquareDistribution", "[", "gradosLibertad", "]"}], ",", 
       RowBox[{"nivelConfianza", "/", "100"}]}], "]"}]}], ";", "  ", 
    RowBox[{"(*", 
     RowBox[{
     "funci\[OAcute]n", " ", "de", " ", "distribuci\[OAcute]n", " ", "Chi", 
      " ", "cuadrado"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Si", " ", "la", " ", "variable", " ", "test1", " ", "toma", " ", "el", 
       " ", "valor", " ", "1"}], ",", " ", 
      RowBox[{
      "no", " ", "rechazamos", " ", "la", " ", "hip\[OAcute]tesis", " ", 
       RowBox[{"nula", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Si", " ", "en", " ", "cambio"}], ",", " ", 
      RowBox[{
      "la", " ", "variable", " ", "test1", " ", "toma", " ", "el", " ", 
       "valor", " ", "0"}], ",", " ", 
      RowBox[{
      "s\[IAcute]", " ", "rechazamos", " ", "la", " ", "hip\[OAcute]tesis", 
       " ", 
       RowBox[{"nula", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"G", "<", "chiCuadrado"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"test1", "=", "1"}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"test1", "=", "0"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   "\"\<Representaci\[OAcute]n gr\[AAcute]fica de los elementos de la serie \
temporal\>\"", "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", "serie", "]"}], "\[IndentingNewLine]", 
   "\"\<Entrop\[IAcute]a de permutaci\[OAcute]n 'H'\>\"", 
   "\[IndentingNewLine]", 
   RowBox[{"N", "[", "H", "]"}], "\[IndentingNewLine]", 
   "\"\<Estad\[IAcute]stico de contraste 'G'\>\"", "\[IndentingNewLine]", 
   RowBox[{"N", "[", "G", "]"}], "\[IndentingNewLine]", 
   "\"\<Distribuci\[OAcute]n Chi cuadrado\>\"", "\[IndentingNewLine]", 
   RowBox[{"N", "[", "chiCuadrado", "]"}], "\[IndentingNewLine]", 
   "\"\<Resultado del test\>\"", "\[IndentingNewLine]", "test1"}]}]], "Input",
 CellChangeTimes->{
  3.5279702423038692`*^9, {3.5279709348603525`*^9, 3.5279709510602407`*^9}, {
   3.527971040555335*^9, 3.5279711019000845`*^9}, {3.5279711393967333`*^9, 
   3.5279711432367396`*^9}, {3.527971175292493*^9, 3.527971191171361*^9}, {
   3.527971421103737*^9, 3.527971483413949*^9}, {3.527971527537363*^9, 
   3.5279715754371786`*^9}, {3.5279723951804724`*^9, 3.527972433780182*^9}, {
   3.5279733790789814`*^9, 3.5279734666149735`*^9}, 3.528112641564727*^9, {
   3.5281127815125723`*^9, 3.5281127842581778`*^9}, {3.528112817236635*^9, 
   3.5281128379690714`*^9}, {3.528112891679966*^9, 3.528112949290867*^9}, {
   3.528113188423687*^9, 3.5281133576839848`*^9}, {3.5281134461673403`*^9, 
   3.528113489644616*^9}, {3.528559796591852*^9, 3.5285598323783154`*^9}, {
   3.5285598905196176`*^9, 3.5285598922356205`*^9}, {3.5285599640541506`*^9, 
   3.528559964834152*^9}, {3.52856000310102*^9, 3.5285600036938205`*^9}, {
   3.528560352354433*^9, 3.528560378437679*^9}, {3.5285604256589613`*^9, 
   3.5285604272501645`*^9}, {3.528560545779173*^9, 3.5285605469023743`*^9}, {
   3.528560580738834*^9, 3.5285605816748357`*^9}, {3.5285608616710353`*^9, 
   3.528560940248373*^9}, {3.528560973039631*^9, 3.528560974303233*^9}, {
   3.5285621840541577`*^9, 3.5285622265486326`*^9}, {3.528562270150709*^9, 
   3.52856233899363*^9}, {3.5285624380694036`*^9, 3.528562478036674*^9}, {
   3.5285625574876137`*^9, 3.528562574834844*^9}, {3.528563267087462*^9, 
   3.5285634148259697`*^9}, {3.5285634790749207`*^9, 3.528563493266508*^9}, {
   3.528563537497721*^9, 3.5285635498019943`*^9}, {3.528563584874525*^9, 
   3.5285635916870923`*^9}, {3.5285644073436174`*^9, 3.528564438057683*^9}, {
   3.5285644953382463`*^9, 3.5285645106745667`*^9}, 3.5285647611843557`*^9, {
   3.528565807308461*^9, 3.528565808233488*^9}, {3.528565854927225*^9, 
   3.5285659612305784`*^9}, {3.5285660865232325`*^9, 
   3.5285660888177123`*^9}, {3.528566199572225*^9, 3.5285662565035467`*^9}, {
   3.5285663252367125`*^9, 3.5285664229912643`*^9}, {3.5285664661922765`*^9, 
   3.5285664702232957`*^9}, {3.5285665021274424`*^9, 3.528566503071494*^9}, {
   3.5285677068932877`*^9, 3.528567718696963*^9}, {3.5285677617118235`*^9, 
   3.528567779769485*^9}, {3.52856784400803*^9, 3.5285678728555217`*^9}, 
   3.5285679044691315`*^9, {3.52856800180381*^9, 3.528568018423834*^9}, {
   3.5285681940363555`*^9, 3.528568269700516*^9}, {3.528568349078614*^9, 
   3.5285683769037423`*^9}, {3.528568427956341*^9, 3.528568488810082*^9}, 
   3.5285685397608776`*^9, {3.5285718467174473`*^9, 3.5285718799004683`*^9}, {
   3.5285743735690765`*^9, 3.528574418375142*^9}, {3.528574451409201*^9, 
   3.5285744517792015`*^9}, {3.528574487281253*^9, 3.5285745229093065`*^9}, {
   3.528574780389892*^9, 3.52857483890707*^9}, 3.528624852207425*^9, 
   3.528624890085291*^9, {3.5286249534370027`*^9, 3.5286249588190117`*^9}, {
   3.5286250355555468`*^9, 3.528625107892874*^9}, {3.52862513995093*^9, 
   3.52862516261777*^9}, 3.5286257211153507`*^9, {3.5286258035302954`*^9, 
   3.5286258421091633`*^9}, {3.5286259051020737`*^9, 3.528625924087308*^9}, {
   3.5286259695145874`*^9, 3.5286260070638533`*^9}, {3.528626196339986*^9, 
   3.5286262600036974`*^9}, {3.528626572877847*^9, 3.5286265902562776`*^9}, {
   3.528626632126751*^9, 3.528626675104827*^9}, {3.5286267116244907`*^9, 
   3.528626791309431*^9}, {3.5286268445377245`*^9, 3.528626890355005*^9}, 
   3.528626977902358*^9, {3.528627011052417*^9, 3.528627054919694*^9}, {
   3.5286275686295958`*^9, 3.5286276060852623`*^9}, {3.5286276615121593`*^9, 
   3.5286277395278964`*^9}, {3.528627785360777*^9, 3.528627828136052*^9}, {
   3.528629696148733*^9, 3.5286297003763404`*^9}, {3.5286394005380955`*^9, 
   3.528639402082498*^9}, {3.528639519051503*^9, 3.528639550095558*^9}, {
   3.5286395815920134`*^9, 3.528639589906828*^9}, {3.5286396365519094`*^9, 
   3.5286396476903296`*^9}, {3.5286396914640064`*^9, 3.52863969910802*^9}, {
   3.52863989869477*^9, 3.528639965182087*^9}, {3.528640021186185*^9, 
   3.5286401921156855`*^9}, {3.5286402364665637`*^9, 3.528640241988973*^9}, {
   3.528640340269146*^9, 3.5286403618283834`*^9}, {3.5286414036918135`*^9, 
   3.5286414615367155`*^9}, {3.528641500895584*^9, 3.5286415042963905`*^9}, {
   3.5286415355744452`*^9, 3.5286415466972647`*^9}, {3.52864158371613*^9, 
   3.528641605088167*^9}, {3.5286416376298246`*^9, 3.5286416854439087`*^9}, {
   3.5286429977940283`*^9, 3.5286431056838174`*^9}, {3.5286431360414705`*^9, 
   3.5286431654319224`*^9}, {3.52864331792219*^9, 3.5286433366734233`*^9}, {
   3.528643445296414*^9, 3.5286434645468473`*^9}, {3.5286436703736095`*^9, 
   3.528643683306032*^9}, {3.5286455546697187`*^9, 3.528645559334127*^9}, {
   3.5286456223114376`*^9, 3.528645630033451*^9}, 3.528645733539633*^9, {
   3.5286460704534245`*^9, 3.5286461061150875`*^9}, {3.5286461568619766`*^9, 
   3.528646252224944*^9}, {3.5286463011466303`*^9, 3.528646315483055*^9}, {
   3.528646384372776*^9, 3.5286463850903773`*^9}, {3.528646480063344*^9, 
   3.5286464848525524`*^9}, {3.5286468249767504`*^9, 
   3.5286468276755548`*^9}, {3.5286468654588213`*^9, 
   3.5286468680328255`*^9}, {3.5286469889330378`*^9, 
   3.5286470236118994`*^9}, {3.52864710412364*^9, 3.5286471360568967`*^9}, 
   3.5286471991122074`*^9, {3.5286472948651752`*^9, 3.528647322602024*^9}, {
   3.529932881942398*^9, 3.5299330031234107`*^9}, {3.52993307656834*^9, 
   3.529933094695572*^9}, {3.529933127362029*^9, 3.529933178062118*^9}, {
   3.5299336769509945`*^9, 3.529933787851589*^9}, 3.5299338194416447`*^9, {
   3.5300415787487955`*^9, 3.5300415905424166`*^9}, {3.5300416814125757`*^9, 
   3.530041696139002*^9}, {3.530041808608068*^9, 3.5300418327569103`*^9}, {
   3.530041882130997*^9, 3.530041916357457*^9}, {3.5300419513171186`*^9, 
   3.5300419618471375`*^9}, {3.530042110156598*^9, 3.5300421109053993`*^9}, {
   3.5300421736487093`*^9, 3.5300422363764195`*^9}, {3.53004260673667*^9, 
   3.53004261789069*^9}, {3.5300426643172507`*^9, 3.5300426772964735`*^9}, 
   3.5300430172210703`*^9, {3.53004314209929*^9, 3.5300432227670317`*^9}, {
   3.5300434921232853`*^9, 3.530043595769635*^9}, {3.530043654154792*^9, 
   3.5300437254545913`*^9}, {3.5300437718189807`*^9, 
   3.5300437725833817`*^9}, {3.530043827036332*^9, 3.5300439163452563`*^9}, {
   3.530044757130978*^9, 3.5300447608800197`*^9}, {3.5301064746791487`*^9, 
   3.5301064803887587`*^9}, {3.530111681659023*^9, 3.53011172713595*^9}, 
   3.5301118203669944`*^9, {3.5301118841444674`*^9, 3.5301119117240314`*^9}, {
   3.5301213709002695`*^9, 3.530121428847866*^9}, {3.5301385426005645`*^9, 
   3.5301385454085693`*^9}, {3.5301386159830933`*^9, 
   3.5301386241107073`*^9}, {3.530138885924114*^9, 3.5301389888218946`*^9}, {
   3.530139032408371*^9, 3.5301390855264645`*^9}, 3.530141129738455*^9, 
   3.530141987256361*^9, 3.530142064445297*^9, {3.530142109248575*^9, 
   3.5301421133357825`*^9}, {3.5301421962811284`*^9, 
   3.5301422030515404`*^9}, {3.532475914323535*^9, 3.5324759224229846`*^9}, {
   3.5324761680215364`*^9, 3.5324762548223276`*^9}, {3.5325215557412605`*^9, 
   3.532521614943364*^9}, {3.532521645535018*^9, 3.532521670495062*^9}, {
   3.5325217827996593`*^9, 3.532521790568473*^9}, {3.5325218484913745`*^9, 
   3.532521850316578*^9}, {3.5325219878776197`*^9, 3.5325220080016546`*^9}, {
   3.532522795893688*^9, 3.532522876132007*^9}, {3.532622670953375*^9, 
   3.53262273079508*^9}, {3.532622765395941*^9, 3.532622999661552*^9}, {
   3.5326230808596945`*^9, 3.5326232919124656`*^9}, {3.532623342784155*^9, 
   3.532623413015478*^9}, {3.532623460673562*^9, 3.532623541122903*^9}, {
   3.532623620636243*^9, 3.532623639091075*^9}, {3.5326236697607293`*^9, 
   3.5326237543752775`*^9}, {3.532623794451748*^9, 3.5326238856651087`*^9}, {
   3.5326240526946015`*^9, 3.532624128463935*^9}, {3.5326241899124427`*^9, 
   3.5326243026850405`*^9}, {3.5326243521839275`*^9, 
   3.5326243958328047`*^9}, {3.532624774305069*^9, 3.5326247833686852`*^9}, {
   3.5326249429725657`*^9, 3.5326249551249866`*^9}, {3.5326250008174667`*^9, 
   3.5326251081924553`*^9}, {3.5326251456793213`*^9, 
   3.5326251581593432`*^9}, {3.532625204101424*^9, 3.5326253614121003`*^9}, {
   3.5326254316434236`*^9, 3.532625504932352*^9}, {3.5326256398101892`*^9, 
   3.532625660137025*^9}, {3.5326333285469713`*^9, 3.5326333332234273`*^9}, {
   3.5326337422498927`*^9, 3.5326337426019125`*^9}, {3.5326337818946733`*^9, 
   3.532633808321912*^9}, {3.5326339306000814`*^9, 3.532633933175022*^9}, {
   3.532634045840314*^9, 3.532634046035325*^9}, {3.5326345475834913`*^9, 
   3.5326345558667517`*^9}, {3.5326347513038273`*^9, 3.532634764566956*^9}, {
   3.5326367184385157`*^9, 3.532636718990547*^9}, {3.532636752382457*^9, 
   3.53263682412656*^9}, {3.532636922792204*^9, 3.532636929599593*^9}, {
   3.532636968421544*^9, 3.5326370637845116`*^9}, 3.532638574678422*^9, {
   3.535585907859319*^9, 3.535585947795389*^9}, {3.535586027527129*^9, 
   3.53558604471836*^9}, {3.535586093858446*^9, 3.5355863720849347`*^9}, {
   3.5355864149226103`*^9, 3.535586441895057*^9}, {3.535586507212372*^9, 
   3.535586589658517*^9}, {3.5355866281593847`*^9, 3.535586937071127*^9}, 
   3.536390882211359*^9, {3.53639108753892*^9, 3.5363910880537205`*^9}, {
   3.5363957851796618`*^9, 3.5363957991572866`*^9}, 3.536398705235612*^9, {
   3.536409835686719*^9, 3.536409844815967*^9}, 3.536410193612796*^9}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 26110, 533, 2495, "Input"]
}
]
*)

(* End of internal cache information *)
